class BackgroundWall {
  //the parent class for all blocks
  
  //global variables
  float x, y;
  PImage original_img, img;
  int x_list_pos, y_list_pos;
  String type, img_name;
  float blockBrightness;
  color currentLightColor;
  
  BackgroundWall(float _x, float _y, int _x_list_pos, int _y_list_pos, String img_name, String _type) {
    //init global variables
    x = _x;
    y = _y;
    original_img = texture_manager.get_texture(img_name);
    img = original_img.get();
    x_list_pos = _x_list_pos;
    y_list_pos = _y_list_pos;
    type = _type;
  }
  
  void update(ArrayList<Light> lights) {
    roughLighting(lights);
    display();
  }
  
  void roughLighting(ArrayList<Light> lights) {
    //rough lightning function
    blockBrightness = 0;
    float temp_r = 0;
    float temp_g = 0;
    float temp_b = 0;
    int light_amount = 0;
    for (Light light : lights) {
      float dist_to_light = dist(x, y, light.x, light.y);
      float current_light_intensity = constrain(light.intensity/pow(dist_to_light/50, 2), 0, light.intensity);
      float tempBrightness = current_light_intensity/10;
      blockBrightness = max(blockBrightness, tempBrightness);
      if (dist_to_light < light.intensity) {
        temp_r += red(light.lightColor)*current_light_intensity;
        temp_g += green(light.lightColor)*current_light_intensity;
        temp_b += blue(light.lightColor)*current_light_intensity;
        light_amount += current_light_intensity;
      }
    }
    temp_r /= light_amount;
    temp_g /= light_amount;
    temp_b /= light_amount;
    currentLightColor = color(temp_r, temp_g, temp_b);
  }
  
  void display() {
    imageMode(CENTER);
    tint(currentLightColor);
    image(img, x, y);
    noTint();
    rectMode(CENTER);
    fill(0, 0, 0, 255-blockBrightness*25);
    rect(x, y, 20, 20);
  }
}