class CustomBlock extends Block {
  //a sub class of block used for most blocks. extremely customizable
  
  PImage img;
  String type;
  
  
  //constructor if the block drops an item (so an item type, image and name are needed)
  CustomBlock(float _x, float _y, int _x_list_pos, int _y_list_pos, String img_name, String block_name, int block_hardness, String item_type, String item_img_name, String item_name, Light light) {
    super(_x, _y, _x_list_pos, _y_list_pos, img_name, block_name, block_hardness, light);
    img = texture_manager.get_texture(img_name);
    item = new Item(texture_manager.get_texture(item_img_name), item_type, item_name);
    super.item = item;
  }
  
  //constructor if the block drops itself
  CustomBlock(float _x, float _y, int _x_list_pos, int _y_list_pos, String img_name, String block_name, int block_hardness, Light light) {
    super(_x, _y, _x_list_pos, _y_list_pos, img_name, block_name, block_hardness, light);
    img = texture_manager.get_texture(img_name);
    item = new Item(texture_manager.get_texture(img_name), "block", block_name);
    super.item = item;
  }
  
  CustomBlock(int _x_list_pos, int _y_list_pos, String block_name) {
    super(_x_list_pos*20-400, _y_list_pos*20, _x_list_pos, _y_list_pos, "dirt_block.png", block_name, -1, null);
    if (block_name.equals("alloy smelter")) {
      super.img =  texture_manager.get_texture("alloy_smelter.png");
      super.item = new Item(super.img, "block", block_name);
    } else if (block_name.equals("amethyst ore")) {
      super.img =  texture_manager.get_texture("amethyst_ore.png");
      super.item = new Item(texture_manager.get_texture("amethyst.png"), "item", "amethyst");
      super.mining_level = 8;
    } else if (block_name.equals("basalt block")) {
      super.img =  texture_manager.get_texture("basalt_block.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 8;
    } else if (block_name.equals("campfire")) {
      super.img =  texture_manager.get_texture("campfire.png");
      super.item = new Item(super.img, "block", block_name);        //light!!
      super.light = new Light(round((player.x+mouseX-width/2)/20)*20, round((player.y+mouseY-height/2)/20)*20, 500, color(255));
    } else if (block_name.equals("coal ore")) {
      super.img =  texture_manager.get_texture("coal_ore.png");
      super.item = new Item(texture_manager.get_texture("coal.png"), "item", "coal");
      super.mining_level = 2;
    } else if (block_name.equals("copper ore")) {
      super.img =  texture_manager.get_texture("copper_ore.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 3;
    } else if (block_name.equals("crafting bench")) {
      super.img =  texture_manager.get_texture("crafting_bench.png");
      super.item = new Item(super.img, "block", block_name);
    } else if (block_name.equals("enchanted wood")) {
      super.img =  texture_manager.get_texture("enchanted_wood.png");
      super.item = new Item(super.img, "block", block_name);
    } else if (block_name.equals("furnace")) {
      super.img =  texture_manager.get_texture("furnace.png");
      super.item = new Item(super.img, "block", block_name);
    } else if (block_name.equals("granite block")) {
      super.img =  texture_manager.get_texture("granite_block.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 6;
    } else if (block_name.equals("iron ore")) {
      super.img =  texture_manager.get_texture("iron_ore.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 5;
    } else if (block_name.equals("potassium ore")) {
      super.img =  texture_manager.get_texture("potassium_ore.png");
      super.item = new Item(texture_manager.get_texture("potassium.png"), "item", "potassium");
      super.mining_level = 7;
    } else if (block_name.equals("quartz ore")) {
      super.img =  texture_manager.get_texture("quartz_ore.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 7;
    } else if (block_name.equals("ruby ore")) {
      super.img =  texture_manager.get_texture("ruby_ore.png");
      super.item = new Item(texture_manager.get_texture("quartz.png"), "item", "quartz");
      super.mining_level = 8;
    } else if (block_name.equals("sapphire ore")) {
      super.img =  texture_manager.get_texture("sapphire_ore.png");
      super.item = new Item(texture_manager.get_texture("ruby.png"), "item", "ruby");
      super.mining_level = 8;
    } else if (block_name.equals("stone block")) {
      super.img =  texture_manager.get_texture("stone_block.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 2;
    } else if (block_name.equals("stoney block")) {
      super.img =  texture_manager.get_texture("stoney_block.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 2;
    } else if (block_name.equals("stone brick")) {
      super.img =  texture_manager.get_texture("stone_brick.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 100000000;
    } else if (block_name.equals("tin ore")) {
      super.img =  texture_manager.get_texture("tin_ore.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 4;
    } else if (block_name.equals("tool station")) {
      super.img =  texture_manager.get_texture("tool_station.png");
      super.item = new Item(super.img, "block", block_name);
    } else if (block_name.equals("thorium ore")) {
      super.img =  texture_manager.get_texture("thorium_ore.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 7;
    } else if (block_name.equals("topaz ore")) {
      super.img =  texture_manager.get_texture("topaz_ore.png");
      super.item = new Item(texture_manager.get_texture("topaz.png"), "item", "topaz");
      super.mining_level = 8;
    } else if (block_name.equals("torch")) {
      super.img =  texture_manager.get_texture("torch.png");
      super.item = new Item(super.img, "block", block_name);
      super.mining_level = 1;
      super.light = new Light(round((player.x+mouseX-width/2)/20)*20, round((player.y+mouseY-height/2)/20)*20, 200, color(255));
      super.collisionPossible = false;
    } else if (block_name.equals("wood")) {
      super.img =  texture_manager.get_texture("wood.png");
      super.item = new Item(super.img, "block", block_name);
    } else if (block_name.equals("wood block")) {
      super.img =  texture_manager.get_texture("wood_block.png");
      super.item = new Item(super.img, "block", block_name);
    } else {
      println(block_name);
      exit();
    }
  }
  
  //updates the block
  void update(ArrayList<Light> lights) {
    super.update(lights);
  }
}