class Cyclops extends Enemy {
  String state;
  int counter, max_counter, shoot_cooldown, max_shoot_cooldown, death_animation_counter;
  float original_x;
  PImage death_animation, original_death_animation;
  float player_x, player_y;
  Cyclops(float temp_x, float temp_y, Block[][] temp_blocks) {
    super(temp_x, temp_y, "cyclops", "cyclops.png", 50, temp_blocks);
    attack = 0;
    health = 80;
    max_health = 80;
    speed = 0;
    attack_cooldown = 50;
    state = "shoot";
    max_counter = 1000;
    counter = max_counter;
    max_shoot_cooldown = 60;
    shoot_cooldown = max_shoot_cooldown;
    original_x = temp_x;
    original_death_animation = texture_manager.get_texture("cyclops_death.png");
    death_animation = original_death_animation.get();
    death_animation_counter = 250;
    player_x = player.x;
    player_y = player.y;
    
    boolean collision = false;
    while (!collision) {
      collision = false;
      for (int i = 0; i < blocks.length; i++) {
        for (int j = 0; j < blocks[i].length; j++) {
          if (blocks[i][j] != null && blocks[i][j].collisionPossible && detectBlockCollision(blocks[i][j])) {
            collision = true;
          }
        }
      }
      if (collision) {
        break;
      }
      location.y++;
    }
  }
  
  void update(Player player) {
    if (state.equals("shoot")) {
      if (shoot_cooldown == 0) {
        for (int i = 0; i < 3; i++) {
          game.enemy_bullets.add(new EnemyBullet(super.location.x, super.location.y, 5, 1000, "cyclops_bullet.png", 5, 0, true));
        }
        game.enemy_bullets.get(game.enemy_bullets.size()-1).rotation += 15;
        game.enemy_bullets.get(game.enemy_bullets.size()-1).velocity.x = game.enemy_bullets.get(game.enemy_bullets.size()-1).speed*cos(radians(game.enemy_bullets.get(game.enemy_bullets.size()-1).rotation));
        game.enemy_bullets.get(game.enemy_bullets.size()-1).velocity.y = game.enemy_bullets.get(game.enemy_bullets.size()-1).speed*sin(radians(game.enemy_bullets.get(game.enemy_bullets.size()-1).rotation));
        game.enemy_bullets.get(game.enemy_bullets.size()-2).rotation -= 15;
        game.enemy_bullets.get(game.enemy_bullets.size()-2).velocity.x = game.enemy_bullets.get(game.enemy_bullets.size()-2).speed*cos(radians(game.enemy_bullets.get(game.enemy_bullets.size()-2).rotation));
        game.enemy_bullets.get(game.enemy_bullets.size()-2).velocity.y = game.enemy_bullets.get(game.enemy_bullets.size()-2).speed*sin(radians(game.enemy_bullets.get(game.enemy_bullets.size()-2).rotation));
        shoot_cooldown = max_shoot_cooldown;
      } else {
        shoot_cooldown--;
      }
    } else if (state.equals("attack")) {
      if (!checkAttackPossible(player)) {
        if (player.x < location.x) {
          location.x = constrain(location.x-3, original_x-350, original_x+350);
        } else {
          location.x = constrain(location.x+3, original_x-350, original_x+350);
        }
      }
    } else if (state.equals("death animation")) {
      if (death_animation_counter > 0) {
        death_animation_counter--;
      } else {
        state = "dead";
        is_dead = true;
        player.x = player_x;
        player.y = player_y;
        for (int i = 0; i < blocks.length; i++) {
          for (int j = 0; j < blocks[i].length; j++) {
              blocks[i][j] = null;
          }
        }
        //player.x = 300;
        game.load_world("world", 0, 0);
      }
    }
    
    if (counter == 0) {
      if (state.equals("shoot")) {
        state = "attack";
        counter = max_counter/5;
      } else {
        state = "shoot";
        counter = max_counter;
      }
    } else {
      counter--;
    }
    if (health <= 0) {
      //is_dead = true;
      state = "death animation";
      for (int i = 0; i < game.enemies.size(); i++) {
        if (game.enemies.get(i).type.equals("cyclops tower")) {
          game.enemies.get(i).is_dead = true;
        }
      }
    }
    display();
  }
  
  void display() {
    if (!state.equals("death animation")) {
      image(img, location.x, location.y);
    } else {
      pushMatrix();
      translate(location.x, location.y);
      death_animation = original_death_animation.get();
      death_animation.resize((250-death_animation_counter+1)*4, (250-death_animation_counter+1)*4);
      rotate(radians(death_animation_counter*3));
      image(death_animation, 0, 0);
      popMatrix();
    }
  }
  
  boolean checkAttackPossible(Player _player) {
    if (attack_cooldown == 0) {
      attack_cooldown = max_attack_cooldown;
      if (location.x > _player.x - _player.img_right.width/2 - img.width/2 && location.x < _player.x + _player.img_right.width/2 + img.width/2 &&
          location.y > _player.y - _player.img_right.height/2 - img.height/2 && location.y < _player.y + _player.img_right.height/2 + img.height/2) {
            _player.damage(attack);
            return true;
      }
    } else {
      attack_cooldown--;
    }
    return false;
  }
}